Unit Direct;

Interface
Uses Crt,graph,Dos,General;

{ͻ
  The following are a set of Turbo 4 procedures for displaying directories 
  and filenames along a given path and returning a user selected or        
  user input filename.                                                     
  Requires CRT,DOS and General.INC and global VAR Regs:Registers;          
  Main Procedures are:                                                     
   ShowFiles: Display an alphabetical list of filenames on a given path.   
   ShowDir: Display an alphabetical list of subdirectory on a given path,  
            with options to change the path.                               
                                                                           
 ͼ}
{****************************************************************************}
TYPE
  SArray=ARRAY[1..264] OF String[12];

PROCEDURE QSORT(VAR SA:SArray; Lo,Hi: integer);
FUNCTION FIXPATH(DPATH:String):STRING;
PROCEDURE GetNewFile(FMask:String;VAR FName:String;Extend:String);
PROCEDURE GetOldFile(FMask:String;VAR Name:String);
PROCEDURE GetAnyFile(FMask:String;VAR Name:String;Extend:String);
PROCEDURE GetExistingSubDirect(DPath:String;ChangeDir:BOOLEAN;VAR Name:String);
Implementation

VAR
  GCard,Tmode,sh,sh3:integer;

{****************************************************************************}
PROCEDURE QSORT(VAR SA:SArray; Lo,Hi: integer);
{Sorts the list of directory or filenames.  Taken from the Quicksort routine
 supplied with Turbo}

Procedure Sort(L,R:Integer);
VAR
  I,J: Integer;
  X,Y :String[12];
BEGIN
  I:=L; J:=R; X:=SA[(L+R) DIV 2];
  REPEAT
    WHILE SA[i]<X DO I:=I+1;
    WHILE X<SA[J] DO J:=J-1;
    IF I<=J then
    BEGIN
      Y:=SA[I]; SA[I]:=SA[J]; SA[J]:=Y;
      I:=I+1; J:=J-1;
    END;{IF}
  UNTIL I>J;
  IF L<J then Sort(L,J);
  if I<R then Sort(I,R);
END;

BEGIN {QSORT};
  Sort(Lo,Hi);
END;{QSORT}
{****************************************************************************}
FUNCTION FIXPATH(DPATH:String):STRING;
{Deals with the Turbo quirk that directory names can't end in '\' except
 root directories which must end in `\` when passed to CHDir. This Function
 will examine a PATH String and attempt to put it in a form that ChDir will
 accept}

VAR
TStr:String[64];
BEGIN
  IF Dpath='' THEN
  BEGIN
    GetDir(0,TStr);
    FixPath:=TStr;
  END
  ELSE IF LENGTH(Dpath)=1 THEN FixPATH:=DPATH + ':\'
  ELSE IF Length(DPath)=2 THEN FixPATH:=DPATH +'\'
  ELSE IF (DPAth[2]<>':') AND (DPAth[Length(DPAth)]='\')
    THEN FIXPATH:=COPY(Dpath,1,Length(DPath)-1);
END;
{****************************************************************************}
PROCEDURE RevVideo(N:Byte);
 {Highlight an entry on the directory list}
VAR
  X,Y,Z:Word;
BEGIN
  X:= 1+((N-1) DIV (sh3))*13;
  Y:= 2+((N-1) MOD (sh3));
  X:= 2*(80*(Y-1)+X)-1;
  IF CardType>0 THEN Y:=$B800 ELSE Y:=$B000;
  FOR Z:=0 to 11 DO Mem[Y:X+2*Z]:=Mem[Y:X+2*Z]+49;
END;{RevVideo}
{****************************************************************************}
PROCEDURE NorVideo(N:Byte);
 {Un-highlight an entry on the directory list}
VAR
  X,Y,Z:Word;
BEGIN
  X:= 1+((N-1) DIV (sh3))*13;
  Y:= 2+((N-1) MOD (sh3));
  X:= 2*(80*(Y-1)+X)-1;
  IF CardType>0 THEN Y:=$B800 ELSE Y:=$B000;
  FOR Z:=0 to 11 DO Mem[Y:X+2*Z]:=Mem[Y:X+2*Z]-49;
END;{NorVideo}
{****************************************************************************}
PROCEDURE PickOffName(N:Byte;VAR Name:String);
{Returns the Nth entry in the directory list}
VAR
  X,Y,Z:WORD;
BEGIN
  Name:='';
  X:= 1+((N-1) DIV (sh3))*13;
  Y:= 2+((N-1) MOD (sh3));
  X:= 2*(80*(Y-1)+X)-2;
  IF CardType>0 THEN Y:=$B800 ELSE Y:=$B000;
  FOR Z:=0 to 11 DO IF Mem[Y:X+2*Z]<>32 THEN
     Name:=Name+CHR(Mem[Y:X+2*Z]);
END;{PickOffName}
{****************************************************************************}
PROCEDURE GetName(N:Byte;VAR Name:String;KeyInput:Boolean);
{Allows user to move highlight around a directory list using arrow keys.
 When 'Enter' key is pressed the highlighted entry is returned in Name.
 N = number of entries on the list.
 If KeyInput=True Then a return occurs if key other than Arrow or Enter hit.

 Uses Procedures
   RevVideo,NorVideo,CursOff,CursOn,PickOffName
}
VAR
  CurNam,A :Byte;
  CH,FK     :CHAR;
  FKeyWaiting:Boolean;
BEGIN
  CursOff;
  RevVideo(1);
  CurNam:=1;
  CH:=#0;
  A:=1;
  REPEAT
    {Check waiting Character. IF KeyInput=true return on non-arrow key}
    CH:=#255;
    Repeat CharReady(CH,FKeyWaiting) Until CH<>#255;
    IF NOT (FKeyWaiting) AND Not (CH In [#13,#27]) AND (KeyInput=TRUE) THEN
    BEGIN
      Name:='';
      NorVideo(CurNam);
      RevVideo(1);
      Exit;
    END;

    FK:=#0;
    REPEAT
      Ch:=ReadKey;
      IF CH=#0 THEN FK:=ReadKey;
    UNTIL (CH IN [#13,#27]) OR (FK IN [#72,#75,#77,#80]) ;
    IF FK<>#0 THEN
    BEGIN
      CASE FK OF
        #72:{Up Arrow}   IF (A-1) In [1..N] THEN A:=A-1;
        #75:{Left Arrow} IF (A-sh3) In [1..N] THEN A:=A-sh3;
        #77:{Right Arrow}IF (A+sh3) In [1..N] THEN A:=A+sh3;
        #80:{Down Arrow} IF (A+1) In [1..N] THEN A:=A+1;
      END;
      IF A In [1..N] THEN
      BEGIN
        NorVideo(CurNam);
        CurNam:=A;
        RevVideo(CurNam);
      END;
    END;
  UNTIL CH IN [#13,#27];

  IF CH=#27 THEN {Escape valve}
  BEGIN
    Name:=#27;
    Exit;
  END;

  PickOffName(CurNam,Name);
  CursOn;
  Norvideo(curnam);
  revvideo(1);

END;{GetName}
{****************************************************************************}
PROCEDURE KeyName(VAR Name:String;Col,Row:Integer;FKey:Boolean;Extend:String);
{Returns a legal filename from the keyboard. THe Cursor is placed at
 positon Col,Row. Illegal characters are not accepted.
 If Extend <> '' then it is forced as the extension.
 Setting Fkey=True forces a return if an arrow key is pressed.
}
VAR
  CH,FK:CHAR;
  FKeyWaiting:Boolean;
  X:Byte;
CONST
  ILLChar='"/\[]:|<>+=;, *?';
BEGIN
  GOTOXY(Col,Row);
  Name:='';
  REPEAT
    {If Fkey =True, return on an arrow key}
    CH:=#255;
    Repeat CharReady(CH,FKeyWaiting) Until CH<>#255;
    IF (FKeyWaiting) AND (Fkey=TRUE) AND (CH in [#72,#75,#77,#80]) THEN
    BEGIN
      GOTOXY(Col,Row);
      Write(' ':(79-Col));
      GotoXY(Col,Row);
      Name:='';
      Exit;
    END;

   {Read in a char}
    CH:=UpCase(ReadKey);
    IF CH=#0 THEN FK:=ReadKey;{Clear function key input}

    {Screen out Illegal Characters};
    IF (Pos(CH,ILLChar)<>0) OR (NOT(CH In [#8,#13,#27,#33..#254])) THEN
    BEGIN
      Beep;
      CH:=#0;
    END;

    CASE CH OF
      #8:{BackSpace except at beginning}
      BEGIN
        IF (WhereX>Col) THEN
        BEGIN
          GotoXY(WhereX-1,WhereY);
          Write(' ');
          GotoXY(WhereX-1,WhereY);
          Name:=Copy(Name,1,Length(Name)-1);
        END;
      END;{Case 1}
      #13,#33..#254:{Legal Character}
      BEGIN
        IF (POS('.',Name)=0) THEN {Working on the name portion}
        BEGIN
          If CH='.' THEN {Period indicates end of name}
          BEGIN
            Name:=Name+CH;
            Write(CH);
            IF Extend<>'' THEN
            BEGIN
              Name:=Name+Extend;
              Write(Extend);
            END;
          END {If}
          ELSE IF CH=#13 THEN
          BEGIN
            IF Name<>''THEN Name:=Name+'.'+Extend Else Name:=#27
          END
          ELSE {Char is not period so add to name if allowed}
          BEGIN
            IF Length(Name)<8 THEN
            BEGIN
              Name:=Name+CH;
              Write(CH);
              IF Length(Name)=8 THEN {check for extension}
              BEGIN
                IF Extend<>'' THEN
                BEGIN
                  Name:=Name +'.'+Extend;
                  Write('.'+Extend);
                END;{if}
              END;{If}
            END {If}
            ELSE Beep;{Error, 8 char already entered, waiting for period}
          END;{Else}
        END {If}
        ELSE {'.' Is Present So Working on the Extension}
        BEGIN
          IF (CH<>'.') AND ((Length(Name)-Pos('.',Name))<3) THEN
          BEGIN
            Name:=Name+CH;
            Write(CH);
          END {If}
          Else Beep;
        END; {Else}
      END;{Case 2}
    END;{Case}
  UNTIL (CH IN [#13,#27]);

  IF Ch=#27 THEN {Escape valve}
  BEGIN
    Name:=#27;
    Exit;
  END;{If}
END;{KeyName}
{****************************************************************************}
FUNCTION NewName(N:Byte;Name:String):BOOLEAN;
{Checks an input file name against the directory list. Returns false
 if a match is found. N= number of entries on the list}
VAR
   X:Byte;
   TName:STRING[12];
BEGIN
  NewName:=TRUE;
  FOR X :=1 to N DO
  BEGIN
    PickOffName(X,TName);
    IF Tname=Name THEN NewName:=FALSE;
  END;{For}
END;{NewName}
{****************************************************************************}
FUNCTION GetDrive:CHAR;
{Returns a legal Drive letter or #27 to signal abort.}
VAR
  CH,Ans:CHAR;
  OKay:Boolean;
  TDir:String[64];
BEGIN
  ClrScr;
  CursOn;
  REPEAT
    WRITELN;
    WRITELN('Enter a Valid Drive Letter :');
    REPEAT CH:=UpCase(READKey) UNTIL CH In [#27,'A'..'Z'];
    IF CH=#27 THEN {Abort}
    BEGIN
      GetDrive:=CH;
      Exit;
    END;
    IF CH in ['A','B'] THEN {Floppy Drive Warning}
    BEGIN
      Writeln;
      Writeln('Be Sure a Formatted Disk Is In Floppy Drive ',CH,'!');
      Writeln('Press a Key To Continue...');
      Ans:=ReadKey;
    END;
    {Test Availability of Drive}
    GetDir(0,TDir);{Save the current drive/directory}
    {$I-}
    CHDir(ch+':\'); {attempt to change to new drive}
    IF IOResult=0 THEN Okay:=True ELSE Okay:=FALSE;
    IF NOT Okay THEN
    BEGIN
      BEEP;
      Writeln('Invalid Drive!!!');
    END;
    CHDir(TDir);{Change back to current drive/directory}
  UNTIL Okay;
  GetDrive:=CH;
END;
{****************************************************************************}
Procedure Checktextmode;
begin
  clrscr;
  Detectgraph(gcard,tmode);
  CASe gcard of
    cga:sh:=25;
    ega:if lastmode>255 then sh:=43 else sh:=25;
    vga:if lastmode>255 then sh:=50 else sh:=25;
    else sh:=25;
  end;
  sh3:=sh-3;
end;
{****************************************************************************}
PROCEDURE ShowFiles(FMask:String; VAR Num:Byte);
{Displays the files on a given path in alphabetical order. FMask must include
 file name and extension , e.g., 'A:\*.*' or 'C:\TXTFILES\*.TXT'.
 Only normal files shown (no directories, hidden files, system files, etc.),
 although you can change the lines indicated to compare S.attr to other values.
 See the Turbo Manual.  Returns the number of entries or 0 in Num if no
 matching entries are found. Will display upto 132 names.
}
VAR
  S:SearchRec;
  SA:Sarray;
  I,J:Integer;
  BA:Array[1..8] OF  String[7];
  BE:Array[1..3] OF String[2];
BEGIN
  Checktextmode;
  BA[1]:='       ';BA[2]:='      ';BA[3]:='     ';BA[4]:='    ';BA[5]:='   ';
  BA[6]:='  ';BA[7]:=' ';BA[8]:='';BE[1]:='  ';BE[2]:=' ';BE[3]:='';
  Num:=0;

  clrscr;
  TextColor(7);

  GOTOXY(1,1);
  WRITE('Directory for: '+FMask);
  GOTOXY(1,2);
  FindFirst(FMask,AnyFile,S);
  IF (DosError=0) AND (S.Attr IN [0,32]) THEN {Change S.Attr here}
  BEGIN                                       {for other types of files}
    Inc(Num);
    IF Pos('.',S.Name)=0 THEN
      SA[Num]:=S.Name+BA[Length(S.Name)]+'.   '+#222
    ELSE
    BEGIN
      I:=Length(S.Name);
      J:=Pos('.',S.name);
      SA[Num]:=COPY(S.name,1,J-1)+BA[J-1]+'.'
               +COPY(S.name,J+1,I-J)+BE[I-J]+#222;
    END;{Else}
  END;{If}

  While (DosError=0) AND (Num<132) DO
  BEGIN
    FindNext(S);
    IF (DosError=0) AND (S.Attr IN [0,32]) THEN {Change S.Attr here}
    BEGIN                                       {for other types of files}
      Inc(Num);
      IF Pos('.',S.Name)=0 THEN
        SA[Num]:=S.Name+BA[Length(S.Name)]+'.   '+#222
      ELSE
      BEGIN
        I:=Length(S.Name);
        J:=Pos('.',S.name);
        SA[Num]:=COPY(S.name,1,J-1)+BA[J-1]+'.'
                +COPY(S.name,J+1,I-J)+BA[I-J]+#222;
      END;{Else}
    END;{If}
  END;{While}

  IF Num=0 THEN
  BEGIN
    Write('No Matching Files in This Directory');
    EXIT;
  END {If}
  ELSE
  BEGIN
    QSort(SA,1,Num);
    FOR I:=1 TO Num DO
    BEGIN
      GOTOXY((1+((i-1) DIV sh3)*13),(2+((i-1) MOD sh3)));
      Write(SA[I]+#222);
    END;{For}
  END;{If}
END;{ShowFiles}
{****************************************************************************}
PROCEDURE GetNewFile(FMask:String;VAR FName:String;Extend:String);
{Display a directory on a path and get from the user a new legal filename
 not on the list. A particular extension can be forced by setting Extend to
 an up to 3 letter string.  If Extend is a null string no checking of the
 extension is made.
 Uses Procedures and Functions:
        ShowFiles,KeyName,NewName,Beep
}
VAR
  N :Byte;
  NewFileName:Boolean;
BEGIN

  ShowFiles(FMask,N);
  If Extend<>''THEN IF Length(Extend)>3 THEN Extend:=COPY(Extend,1,3);
  GoTOXY(1,sh-1);
  WRITE('Enter a new filename NOT on this list (8 Char Max): ');
  REPEAT
    KeyName(FName,52,sh-1,False,Extend);
    IF Fname=#27 THEN
    BEGIN
      Fname:='';
      Exit;
    END;

    {Check If this is a legal new filename}
    NewFileName:=NewName(N,FName);

    IF NOT NewFileName THEN
    BEGIN
      Beep;
      GOTOXY(52,sh-1);
      WRITE('Not a NEW Filename!! ');
      Delay(2000);
      GOTOXY(52,sh-1);
      WRITE('                            ');
      GOTOXY(52,sh-1);
    END;{If}
  UNTIL NewFileName=TRUE;
  clrscr;
  CursOn;
END;{GetNewFile}
{****************************************************************************}
PROCEDURE GetOldFile(FMask:String;VAR Name:String);
{Returns a user selected name of an existing file on a given path.
 If no files present returns empty string in Name.
 Uses Procedures and Functions:
      ShowFiles, GetName, Beep
}
VAR
  N  :Byte;

BEGIN

  ShowFiles(FMask,N);

  IF N=0 THEN
  BEGIN
    Name:='';
    Beep;
    Delay(2000);
    Exit;
  END;{If}

  GOTOXY(1,sh);
  Write('Use '#24#25#26#27' and the ENTER key to pick a file from this list');
  GetName(N,Name,False);
  IF Name=#27 THEN Name:='';
  clrscr;
  curson;
END;{GetOldFIle}
{****************************************************************************}
PROCEDURE GetAnyFile(FMask:String;VAR Name:String;Extend:String);
{Returns a user selected or input name of a file on a given path.
 If no files present returns empty string in Name.
 Uses Procedures and Functions:
      ShowFiles, GetName, Beep
}
VAR
  N :Byte;
  CH,Ans:CHAR;
  FKey,KeyInput:BOOLEAN;
BEGIN
  ShowFiles(FMask,N);

  GOTOXY(1,sh-1);
  Write
    ('Use '#24#25#26#27' and the ENTER key to pick a file from this list ');
  GOTOXY(1,sh);
  Write ('OR Enter a Legal Filename from the Keyboard: ');

  IF N=0 THEN {No option but to enter from keyboard}
  BEGIN
    KeyName(Name,46,sh,False,Extend);
  END
  ELSE  {Pick from list or enter from keyboard}
  BEGIN
    KeyInput:=False;
    REPEAT
      IF NOT KeyInput THEN
      Begin
        CursOff;
        GetName(N,Name,True);
        Curson;
      End
      Else
      BEGIN
        NorVideo(1);
        KeyName(Name,46,sh,True,Extend);
      END;
      If Not NewName(N,Name) THEN
      BEGIN
        Beep;
        GotoXY(1,sh);
        Write(' ':79);
        GOTOXY(1,sh);
        Write(
 'Warning! File Exists! Enter <Y> to Accept or Any Other Key to Re-Do Name.');
        Ans:=UpCase(ReadKey);If Ans=#0 THEN Ans:=ReadKey;
        IF Ans<>'Y' THEN
        Begin
          Name:='';
          GOTOXY(1,sh);
          Write(' ':79);
          GOTOXY(1,sh);
          Write ('OR Enter a Legal Filename from the Keyboard: ');
        END;
      END;
      KeyInput:=NOT Keyinput;
    UNTIL Name<>'';
  END;
  IF Name=#27 THEN Name:='';
  clrscr;
  CursOn;
END;{GetAnyFile}

{****************************************************************************}
PROCEDURE ShowDir(DPath:String; ChangeDir:BOOLEAN; VAR Num:Byte);

{Displays alphabetical list of SubDirectories on DPath. DPath should end
in a '\'. Returns the number of entries. First entries is always Dpath itself.
If ChangeDir is set to TRUE, then next three entries will be Back.One.Dir,
Root.Dir and New.Drive. Upto 132 names displayed.
}
VAR
  S:SearchRec;
  SA:Sarray;
  I,J,SNum:Integer;
  BA:Array[1..8] OF  String[7];
  BE:Array[1..3] OF String[2];
BEGIN
  Checktextmode;
  BA[1]:='       ';BA[2]:='      ';BA[3]:='     ';BA[4]:='    ';BA[5]:='   ';
  BA[6]:='  ';BA[7]:=' ';BA[8]:='';BE[1]:='  ';BE[2]:=' ';BE[3]:='';
  Clrscr;
  GOTOXY(1,1);
  clrscr;
  TextColor(7);
  Write('Currently Selected Directory: ',DPath);
  GOTOXY(1,2);
  Write('This.Dir.OK ',#222);
  Num:=1;

  {Options for changing to a different Path}
  IF ChangeDir=TRUE THEN
  BEGIN
    Inc(Num);
    GOTOXY((1+((Num-1) DIV sh3)*13),(2+((Num-1) MOD sh3)));
    WRITE('Back.One.Dir',#222);
    INC(Num);
    GOTOXY((1+((Num-1) DIV sh3)*13),(2+((Num-1) MOD sh3)));
    WRITE('Root.Dir    ',#222);
    Inc(Num);
    GOTOXY((1+((Num-1) DIV sh3)*13),(2+((Num-1) MOD sh3)));
    WRITE('New.Drive   ',#222);
  END;
  SNum:=Num+1;

  FindFirst(DPath+'*.*',AnyFile,S);
  IF (DosError=0) AND (S.Attr AND $10 <>0 ) AND (S.Name[1]<>'.') THEN
  BEGIN
    Inc(Num);
    IF Pos('.',S.Name)=0 THEN
      SA[Num]:=S.Name+BA[Length(S.Name)]+'    '+#222
    ELSE
    BEGIN
      I:=Length(S.Name);
      J:=Pos('.',S.name);
      SA[Num]:=COPY(S.name,1,J-1)+BA[J-1]+' '
               +COPY(S.name,J+1,I-J)+BE[I-J]+#222;
    END;
  END;

  {List the names)}
  While (DosError=0) AND (Num<132) DO
  BEGIN
    FindNext(S);
    IF (DosError=0) AND (S.Attr AND $10 <>0) AND (S.Name[1]<>'.') THEN
    BEGIN
      Inc(Num);
      IF Pos('.',S.Name)=0 THEN
        SA[Num]:=S.Name+BA[Length(S.Name)]+'    '+#222
      ELSE
      BEGIN
        I:=Length(S.Name);
        J:=Pos('.',S.name);
        SA[Num]:=COPY(S.name,1,J-1)+BA[J-1]+' '
                 +COPY(S.name,J+1,I-J)+BE[I-J]+#222;
      END;
    END;{If}
  END;{While}

  IF Num=0 THEN
  BEGIN
    Write('No SubDirectories in This Directory');
    EXIT;
  END
  ELSE
  BEGIN
    IF Num>=SNum THEN
    BEGIN
      QSort(SA,SNum,Num);
      FOR I:=SNum TO Num DO
      BEGIN
        GOTOXY((1+((i-1) DIV sh3)*13),(2+((i-1) MOD sh3)));
        Write(SA[I]+#222);
      END;
    END;
  END;

END;{ShowDir}
{****************************************************************************}
PROCEDURE GetExistingSubDirect(DPath:String;ChangeDir:BOOLEAN;VAR Name:String);

{Returns a user selected name of an existing SubDirectory on a given path.
 IF ChangeDir is TRUE then options to change to a different Drive/Directory
 are given. Tries to anticipate various ways DPath might be specified, e.g.
 empty string converted to current drive/directory. Returns the Path with a
 final '\'.  Remember to use the Turbo CHDir procedure to leave the '\' if
 specifying a root directory, but strip it if specifying a subdirectory.
 Very Confusing!! The FixPath function may help.

 Uses Procedures and Functions
      ShowDir,GetName,Beep
}
VAR
  N,I  :Byte;
  D:CHAR;
  Tstr:String;
  Drive:String[3];
  DirName:String;
  Done:Boolean;

BEGIN
  CursOff;
  Drive:='';
  DirName:='';
  Tstr:='';

  {Attempt to Reformat Dpath if necessary}
  GetDir(0,Tstr);
  IF DPATH='' THEN DPATH:=Tstr;      {Convert Null String to present Drive\Dir}
  IF DPATH[2]<>':'THEN               {No Drive Spec In DPath}
    IF DPATH[1]='\' THEN             {So add the current}
       DPATH:=Tstr[1]+':'+DPath      {Drive to beginning of}
    ELSE Dpath:=TStr[1]+':\'+DPath;  {DPath}
  IF DPath[Length(DPath)]<>'\' THEN  {Add a Trailing <\> To DPath if required}
      Dpath:=DPath+'\';
  Drive:=Copy(DPath,1,3);

  REPEAT
    Done:=FALSE;
    ShowDir(DPath,ChangeDir,N);
    GOTOXY(1,sh);
    Write('Use '#24#25#26#27' and ENTER to Select Directory on this List.');
    GetName(N,Name,False);

    IF Name=#27 THEN
    BEGIN
      Name:=Dpath;
    END
    ELSE IF Name='This.Dir.OK' THEN
    BEGIN
      Name:=DPath;
      Done:=TRUE;
    END
    ELSE IF Name='Root.Dir' THEN Name:=Drive
    ELSE IF Name='New.Drive' THEN
    BEGIN
      D:=GetDrive;
      CursOff;
      IF D <>#27 THEN
      BEGIN
        Drive:=D+':\';
        Name:=Drive;
      END
      ELSE Name:=DPAth;
    END
    ELSE IF Name='Back.One.Dir' THEN
    BEGIN
      IF Length(Dpath)>3 THEN
      BEGIN
        I:=Length(Dpath)-1;
        REPEAT Dec(I) UNTIL Dpath[I]='\';
        Name:=COPY(Dpath,1,I);
      END
      ELSE Name:=DPath;
    END
    ELSE Name:= DPath+Name+'\';
    DPath:=Name;
  UNTIL Done=TRUE;
  CursOn;
  clrscr;
END;{GetExistingSubDirect}

End.